#! /usr/bin/env python

from elementtree.ElementTree import XML, tostring
from getopt import getopt, GetoptError
from sss.ssslib import comm_lib
from string import join
from sys import argv, exit
from os import getlogin

if __name__ == '__main__':
    try:
        (opts,args) = getopt(argv[1:], 'sgu:p:r:a:')
    except GetoptError, e:
        print e
        print "Usage: camadmin -s [-u user1] [-r user2] [-a allocation(-1 for unlimited)] project1 .. projectN","\n","Usage2: camadmin -g [-u user1] [-p project1]"
        exit(1)

    mode='none'
    for x in opts:
        if (x[0] == '-s'):
            mode='set'


    if (mode=='set'):
    
        users = [x[1] for x in opts if x[0] == '-u']
        rusers = [x[1] for x in opts if x[0] == '-r']
        allocations = [x[1] for x in opts if x[0] == '-a']
        if allocations:
            allocation = allocations[0]
        else:
            allocation = '-1'
        projects = args
    
        comm = comm_lib(debug=0)
        h = comm.ClientInit('allocation-manager')
        emsg = '''<get-project><project name='%s'><user name='%s'/></project></get-project>'''
        amsg = '''<add-project><project name='%s' allocation='%s'>%s</project></add-project>'''
        smsg = '''<set-project allocation='%s'><project name='%s'></project></set-project>'''
        aumsg = '''<add-user user='%s'><project name='%s'/></add-user>'''
        dumsg = '''<del-user user='%s'><project name='%s'/></del-user>'''
        
        for project in projects:
            # does project exist
            comm.SendMessage(h, emsg%(project,'*'))
            r = comm.RecvMessage(h)
            rx = XML(r)
            if not rx.findall("project"):
                u = join(map(lambda x:"<user name='%s'/>"%(x), users))
                comm.SendMessage(h, amsg%(project,allocation,u))
                r = comm.RecvMessage(h)
                rx = XML(r)
                continue
            comm.SendMessage(h, smsg%(allocation, project))

            # project exists and we need to add users
            pusers =[]
            for aproject in rx.findall("project"):
               for auser in aproject.findall("user"):
                   pusers.append(auser.attrib['name'])
   
            for user in users:
                if user not in pusers:
                    comm.SendMessage(h, aumsg%(user, project))
                    r = comm.RecvMessage(h)
            for ruser in rusers:
                if ruser in pusers:
                    comm.SendMessage(h, dumsg%(ruser, project))
                    r = comm.RecvMessage(h)
        comm.ClientClose(h)
        
    else:
    
        user = '*'
        project ='*'
        
        users = [x[1] for x in opts if x[0] == '-u']
        if users:
            user = users[0]
        projects = [x[1] for x in opts if x[0] == '-p']
        if projects:
            project = projects[0]
        
        c = comm_lib(debug=0)
        h = c.ClientInit('allocation-manager')
        c.SendMessage(h, '''<get-project><project name='%s' allocation='*'><user name='%s'/></project></get-project>'''%(project,user))
        r = c.RecvMessage(h)
        c.ClientClose(h)
        
        rx=XML(r)
        
        for project in rx.findall("project"):

            if project.attrib['allocation'] == "-1.0":
                allocation = "Unlimited"
            else:
                allocation = project.attrib['allocation']
            print "Project:","        ",allocation,"(allocation)\n","         ",project.attrib['name'],"\n","Users:"
            for user in project.findall("user"):
                print "         ",user.attrib['name']
            print "\n"
