#!/usr/bin/env python

'''Cobalt queue delete'''
__revision__ = '$Revision: 1.2 $'

from sss.ssslib import comm_lib
from sys import argv
from elementtree.ElementTree import XML

import pwd
import os

from Cobalt.Util import print_tabular

if __name__ == '__main__':
    if '--version' in argv:
        print "cqdel %s" % __revision__
    if len(argv) < 2:
        print "Usage: cqdel [-f] <jobid>"
        raise SystemExit, 1

    user = pwd.getpwuid(os.getuid())[0]
    comm = comm_lib(debug=('-d' in argv))
    handle = comm.ClientInit("queue-manager")
    if '-f' in argv:
        comm.SendMessage(handle,"<del-job force='true'><job user='%s' jobid='%s'/></del-job>" % (user, argv[-1]))
    else:
        comm.SendMessage(handle,"<del-job><job user='%s' jobid='%s'/></del-job>" % (user, argv[-1]))
    xdata = comm.RecvMessage(handle)
    comm.ClientClose(handle)
    resp = XML(xdata)

    data = [('JobID','User')] + [(job.get('jobid'), job.get('user')) for job in resp.findall('.//job')]

    print "      Deleted Jobs"
    print_tabular(data)

