#!/usr/bin/env python

from elementtree.ElementTree import Element, SubElement, tostring
from getopt import getopt, GetoptError
from sss.ssslib import comm_lib
from sys import argv

if __name__ == '__main__':
    try:
        (opts, args) = getopt(argv[1:], 'p:', [])
    except GetoptError, msg:
        print msg
        print "releaseres -p <partition> name"
        raise SystemExit, 1

    msg = Element("DelReservation", name=args[0])
    if opts:
        SubElement(msg, "Partition", name=opts[0][1])
    else:
        SubElement(msg, "Partition", name='*')

    comm = comm_lib()
    handle = comm.ClientInit('scheduler')
    comm.SendMessage(handle, tostring(msg))
    print comm.RecvMessage(handle)
    comm.ClientClose(handle)
    
