#!/usr/bin/env python

from sss.ssslib import comm_lib
from sys import argv
from elementtree.ElementTree import XML, tostring
from time import localtime, strftime

if __name__ == '__main__':
    comm = comm_lib(debug='-d' in argv)
    handle = comm.ClientInit('scheduler')
    comm.SendMessage(handle,
                     '''<GetPartition><Partition name="*"><Reservation name="*" start="*" duration="*" user="*"/></Partition></GetPartition>''')
    r = comm.RecvMessage(handle)
    for partition in XML(r).findall('.//Partition'):
        print "Partition: %s" % partition.get('name')
        for reservation in partition.findall('Reservation'):
            stm = strftime("%c",localtime(float(reservation.get('start')))).replace(' ', '_')
            user = reservation.get('user')
            if user in ['BUG', '']:
                user = "<none>"
            print "User: %s Start: %s Duration: %s Name: %s" % (user, stm, reservation.get('duration'), reservation.get('name'))

                     
